/*******************************************************************************
 *	@file			DL.cpp
 *	@brief			DirectX Library
 *
 *	@date			08-Apr-2009(Wed)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "DL.h"
#include "DLGraph.h"

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// O[oϐ---------------------------------------------------------
CDLGraph			g_CGraph;

// ֐vg^Cv錾---------------------------------------------------

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				int LoadNull( const SDLMaterial& SDL )
 *	@param[in]		SDL							fޏ\
 *	@retval			int							fޔԍ
 *	@brief			fޓǂݍ݁iNULLj
 ******************************************************************************/
int LoadNull( const SDLMaterial& SDL )
{
	return -1;
}

/*******************************************************************************
 *	@fn				int LoadGraph( const SDLMaterial& SDL )
 *	@param[in]		SDL							fޏ\
 *	@retval			int							fޔԍ
 *	@brief			fޓǂݍ݁iDirectX Graphicsj
 ******************************************************************************/
int LoadGraph( const SDLMaterial& SDL )
{
	return g_CGraph.Load( SDL );
}

/*******************************************************************************
 *	@fn				int RemoveNull( const SDLMaterial& SDL )
 *	@param[in]		SDL							fޏ\
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			fމiNULLj
 ******************************************************************************/
int RemoveNull( const SDLMaterial& SDL )
{
	return TRUE;
}

/*******************************************************************************
 *	@fn				int RemoveGraph( const SDLMaterial& SDL )
 *	@param[in]		SDL							fޏ\
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			fމiDirectX Graphicsj
 ******************************************************************************/
int RemoveGraph( const SDLMaterial& SDL )
{
	return g_CGraph.Remove( SDL );
}

// -----------------------------------------------------------------------------
// o[֐|C^ifޓǂݍ݁j
int ( *StepLoad[ enumMaterial_Max ] )( const SDLMaterial& SDL ) =
{
	&LoadNull,
	&LoadGraph, &LoadGraph,
};
// o[֐|C^ifމj
int ( *StepRemove[ enumMaterial_Max ] )( const SDLMaterial& SDL ) =
{
	&RemoveNull,
	&RemoveGraph, &RemoveGraph,
};

/*******************************************************************************
 *	@fn				int Init( const SDLParam& SDL )
 *	@param[in]		SDL							\
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			DirectX ̏
 ******************************************************************************/
int Init( const SDLParam& SDL )
{
	// COM̏
	::CoInitialize( NULL );
	// DLGraph̏
	if( !g_CGraph.Init( SDL ) ) return FALSE;

	return TRUE;
}

/*******************************************************************************
 *	@fn				int Exit( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			DirectX ̏I
 ******************************************************************************/
int Exit( void )
{
	// DLGraph̏I
	g_CGraph.End();
	// COM̉
	::CoUninitialize();

	return TRUE;
}

/*******************************************************************************
 *	@fn				int Exec( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			DirectX ̎s
 ******************************************************************************/
int Exec( void )
{
	// \[g
	g_CGraph.Sort();
	// ʍXV
	g_CGraph.Update();

	return TRUE;
}

/*******************************************************************************
 *	@fn				int Load( const SDLMaterial& SDL )
 *	@param[in]		SDL							fޏ\
 *	@retval			int							fޔԍ
 *	@brief			fޓǂݍ
 ******************************************************************************/
int Load( const SDLMaterial& SDL )
{
	return ( *StepLoad[ SDL.m_eMat ] )( SDL );
}

/*******************************************************************************
 *	@fn				int Remove( const SDLMaterial& SDL )
 *	@param[in]		SDL							fޏ\
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			fމ
 ******************************************************************************/
int Remove( const SDLMaterial& SDL )
{
	return ( *StepRemove[ SDL.m_eMat ] )( SDL );
}

/*******************************************************************************
 *	@fn				int ChangeDisplay( const SDLParam& SDL )
 *	@param[in]		SDL							\
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			ʐ؂ւ
 ******************************************************************************/
int ChangeDisplay( const SDLParam& SDL )
{
	return g_CGraph.ChangeDisplay( SDL );
}

/*******************************************************************************
 *	@fn				int Add( const SDLGraph& SDL )
 *	@param[in]		SDL							IuWFNg\
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			IuWFNgǉ
 ******************************************************************************/
int Add( const SDLGraph& SDL )
{
	return g_CGraph.Add( SDL );
}

/*******************************************************************************
 *	@fn				int Del( const SDLGraph& SDL )
 *	@param[in]		SDL							IuWFNg\
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			IuWFNg폜
 ******************************************************************************/
int Del( const SDLGraph& SDL )
{
	return g_CGraph.Del( SDL );
}

}	// namespace	DL
