/*******************************************************************************
 *	@file			DL.h
 *	@brief			DirectX Library
 *
 *	@date			08-Apr-2009(Wed)
 ******************************************************************************/

#ifndef	__DL_INCLUDE__
#define	__DL_INCLUDE__

// ܂Ȃ
#define STRICT																	//!< ^`FbNɍs
#define	WIN32_LEAN_AND_MEAN														//!< wb_[炠܂gȂ֐Ȃ

// vvZbT---------------------------------------------------------------
//#pragma warning( disable : 4995 )
// Windows Library
#pragma comment ( lib, "winmm.lib" )
// DirectX Library
#pragma comment ( lib, "d3d9.lib" )
#pragma comment ( lib, "d3dx9.lib" )
#pragma comment ( lib, "dxerr9.lib" )
#pragma comment ( lib, "dxguid.lib" )

// Windows
#include <windows.h>
#include <tchar.h>
#include <assert.h>

// DirectX9
#include <d3dx9.h>																//!< Direct3D & Direct3DX
#include <dxerr9.h>																//!< DirectX̃G[

// _DXLibv2

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// 萔`---------------------------------------------------------------------
#define EXIT				1
#define TRUE				1
#define FALSE				0

#define _RELEASE( x )		if( x != NULL ){ x->Release(); x = NULL; }
#define _MEMCHECK( m )		if( m != NULL ){ ::free( m ); m = NULL; }

#ifdef	_DEBUG
	#define _ASSERT( n )	assert( n );
#else	// _DEBUG
	#define _ASSERT( n )	{}
#endif	// _DEBUG

// 񋓌^`-------------------------------------------------------------------
/*******************************************************************************
 *	@struct		enumMaterial	DL.h			"DL.h"
 *	@brief		fޏ
 ******************************************************************************/
enum enumMaterial
{
	enumMaterial_Null		= 0,												//!< Ȃ
	// DirectX Graphics
	enumMaterial_GraphStart,
	enumMaterial_Bmp		= enumMaterial_GraphStart,							//!< 摜
	enumMaterial_GraphEnd,
	// 
	enumMaterial_Max,
};

/*******************************************************************************
 *	@struct		enumObject		DL.h			"DL.h"
 *	@brief		IuWFNg
 ******************************************************************************/
enum enumObject
{
	enumObject_Null			= 0,												//!< Ȃ
	enumObject_Rect,															//!< `(RECTgp)
	enumObject_Plane,															//!< 
	enumObject_Max,
};

/*******************************************************************************
 *	@struct		enumDraw		DL.h			"DL.h"
 *	@brief		`
 ******************************************************************************/
enum enumDraw
{
	enumDraw_Null			= 0,												//!< Ȃ
	enumDraw_On,																//!< `悷
	enumDraw_Off,																//!< `悵Ȃ
	enumDraw_Max,
};

/*******************************************************************************
 *	@struct		enumState		DL.h			"DL.h"
 *	@brief		Xe[g
 ******************************************************************************/
enum enumState
{
	enumState_Null			= 0,												//!< Ȃ
	enumState_Translucent,														//!< 
	enumState_Add,																//!< Z
	enumState_Sub,																//!< Z
	enumState_Max,
};

// \̒`-------------------------------------------------------------------
/*******************************************************************************
 *	@struct		SDLParam		DL.h			"DL.h"
 *	@brief		DL\
 ******************************************************************************/
struct SDLParam
{
	SDLParam( void )
		: m_hWnd()
		, m_nWidth( 0 )
		, m_nHeight( 0 )
		, m_bMode( TRUE )
	{
	}

	// DirectX Graphics
	HWND					m_hWnd;												//!< EChEnh
	int						m_nWidth;											//!< 
	int						m_nHeight;											//!< 
	BOOL					m_bMode;											//!< EChE[h
};

/*******************************************************************************
 *	@struct		SDLMaterial		DL.h			"DL.h"
 *	@brief		fޏ\
 ******************************************************************************/
struct SDLMaterial
{
	// {
	int						m_nID;												//!< hcԍ
	enumMaterial			m_eMat;												//!< fޏ
	// eNX`
	LPCSTR					m_szName;											//!< t@C
	DWORD					m_dwColor;											//!< ߐF
	// 
};

/*******************************************************************************
 *	@struct		SDLGraph		DL.h			"DL.h"
 *	@brief		DirectX Graphics \
 ******************************************************************************/
struct SDLGraph
{
	// {
	int						m_nID;												//!< hcԍ
	enumObject				m_eObj;												//!< IuWFNg
	int						m_nPrio;											//!< `vCIeB

	// f
	int						m_nMatNum;											//!< fޔԍ
	// `
	enumDraw				m_eDraw;											//!< `tO
	enumState				m_eState;											//!< Xe[gtO
	// f[^
	void*					m_pData0;											//!< ėpf[^O
	void*					m_pData1;											//!< ėpf[^P
	void*					m_pData2;											//!< ėpf[^Q
	void*					m_pData3;											//!< ėpf[^R
};

/*******************************************************************************
 *	@struct		SDLPlane		DL.h			"DL.h"
 *	@brief		ʏ\
 ******************************************************************************/
struct SDLPlane
{
	float					m_fX;												//!< wW
	float					m_fY;												//!< xW
	float					m_fZ;												//!< yW
	int						m_nC;												//!< F
};

// NX-----------------------------------------------------------------------

// OO[oϐ---------------------------------------------------------

// O֐vg^Cv錾---------------------------------------------------
int Init( const SDLParam& SDL );
int Exit( void );
int Exec( void );

// fފ֘A
int Load( const SDLMaterial& SDL );												//!< fޓǂݍ
int Remove( const SDLMaterial& SDL );											//!< fމ

// DirectX Graphics
int ChangeDisplay( const SDLParam& SDL );										//!< ʐ؂ւ
int Add( const SDLGraph& SDL );													//!< IuWFNgǉ
int Del( const SDLGraph& SDL );													//!< IuWFNg폜

}	// namespace	DL

#ifdef __cplusplus
}
#endif

#endif	// __DL_INCLUDE__
