/*******************************************************************************
 *	@file			DLGraph.h
 *	@brief			DirectX Library
 *
 *	@date			21-Apr-2010(Wed)
 ******************************************************************************/

#ifndef	__DLGRAPH_INCLUDE__
#define	__DLGRAPH_INCLUDE__

// vvZbT---------------------------------------------------------------
#include "DL.h"

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// 萔`---------------------------------------------------------------------
#pragma once

// 񋓌^`-------------------------------------------------------------------

// \̒`-------------------------------------------------------------------
/*******************************************************************************
 *	@struct		D3DVERTEX		DLGraph.h		"DLGraph.h"
 *	@brief		_\
 ******************************************************************************/
struct D3DVERTEX
{
	float		x, y, z;														//!< ʒuW
	float		rhw;															//!< ̋t
	D3DCOLOR	color;															//!< _F
	float		tu, tv;															//!< eNX`W
};

/*******************************************************************************
 *	@struct		D3DTEXTURE		DLGraph.h		"DLGraph.h"
 *	@brief		eNX`\
 ******************************************************************************/
struct D3DTEXTURE
{
	D3DTEXTURE()
		: m_lpD3DTex( NULL )
		, m_D3DDesc()

		, m_szName()
		, m_dwColor( 0x00000000 )
	{
	}

	//
	LPDIRECT3DTEXTURE9	m_lpD3DTex;												//!< eNX`
	D3DSURFACE_DESC		m_D3DDesc;												//!< \[X

	LPCSTR				m_szName;												//!< O
	DWORD				m_dwColor;												//!< ߐF
};

/*******************************************************************************
 *	@struct		D3DOBJECT		DLGraph.h		"DLGraph.h"
 *	@brief		IuWFNg\
 ******************************************************************************/
struct D3DOBJECT
{
	D3DOBJECT()
		: m_bUsed( FALSE )
		, m_nPrio( -1 )
		, m_nMatNum( -1 )
		, m_eDraw( enumDraw_Null )
		, m_pD3DState( NULL )
		, m_nDataMax( 0 )
		, m_pData( NULL )
	{
	}

	// {
	BOOL					m_bUsed;											//!< gptO
	int						m_nPrio;											//!< `vCIeB

	// f
	int						m_nMatNum;											//!< fޔԍ

	// `
	enumDraw				m_eDraw;											//!< `tO
	LPDIRECT3DSTATEBLOCK9	m_pD3DState;										//!< Xe[gubN

	// f[^
	int						m_nDataMax;											//!< f[^
	D3DVERTEX*				m_pData;											//!< f[^
};

// NX-----------------------------------------------------------------------
/*******************************************************************************
 *	@class		CDLGraph		DLGraph.h			"DLGraph.h"
 *	@brief		CDLGraphNX
 ******************************************************************************/
class CDLGraph
{
// 萔`---------------------------------------------------------------------
private:
	static const int TEXTURE_MAX	= 128;										//!< eNX`
	static const int OBJECT_MAX		= 256;										//!< IuWFNg

protected:
public:

// o֐-------------------------------------------------------------------
private:
	static int ( CDLGraph::*StepLoad[ enumMaterial_GraphEnd - enumMaterial_GraphStart ] )( const SDLMaterial& SDL, const int& nNum );
	static int ( CDLGraph::*StepRemove[ enumMaterial_GraphEnd - enumMaterial_GraphStart ] )( const int& nNum );
	static int ( CDLGraph::*StepAdd[ enumObject_Max ] )( const SDLGraph& SDL, const int& nNum );
	static int ( CDLGraph::*StepDel[ enumObject_Max ] )( const int& nNum );

	BOOL SetViewPort( const SDLParam& SDL );									//!< r[|[g̐ݒ
	BOOL DeviceRestore( const HRESULT& hRes );									//!< foCX̕
	void SetState( const SDLGraph& SDL, D3DOBJECT* Obj );						//!< Xe[g̐ݒ

	// fޓǂݍ
	int LoadNull( const SDLMaterial& SDL, const int& nNum );					//!< ǂݍ݂Ȃ
	int LoadBmp( const SDLMaterial& SDL, const int& nNum );						//!< 摜ǂݍ

	// fމ
	int RemoveNull( const int& nNum );											//!< Ȃ
	int RemoveBmp( const int& nNum );											//!< 摜

	// IuWFNgǉ
	int AddNull( const SDLGraph& SDL, const int& nNum );						//!< ǉȂ
	int AddRect( const SDLGraph& SDL, const int& nNum );						//!< `ǉ
	int AddPlane( const SDLGraph& SDL, const int& nNum );						//!< ʒǉ

	// IuWFNg폜
	int DelNull( const int& nNum );												//!< 폜Ȃ
	int DelRect( const int& nNum );												//!< `폜
	int DelPlane( const int& nNum );											//!< ʍ폜

protected:
public:
	CDLGraph( void );
	~CDLGraph( void );

	int Init( const SDLParam& SDL );											//!< 
	int End( void );															//!< I

	int Sort( void );															//!< \[g
	int Update( void );															//!< ʍXV

	int ChangeDisplay( const SDLParam& SDL );									//!< ʐ؂ւ

	// fފ֘A
	int Load( const SDLMaterial& SDL );											//!< fޓǂݍ
	int Remove( const SDLMaterial& SDL );										//!< fމ

	// IuWFNg֘A
	int Add( const SDLGraph& SDL );												//!< IuWFNgǉ
	int Del( const SDLGraph& SDL );												//!< IuWFNg폜

// oϐ-------------------------------------------------------------------
private:
	LPDIRECT3D9				m_lpD3D;											//!< Direct3D IuWFNg
	LPDIRECT3DDEVICE9		m_lpD3DDev;											//!< Direct3D foCX

	HWND					m_hWnd;												//!< EChEnh
	D3DPRESENT_PARAMETERS	m_D3DPP;											//!< foCX\
	D3DDISPLAYMODE			m_D3DDM;											//!< fBXvC̏
	D3DVIEWPORT9			m_D3DVP;											//!< r[|[g\

	// \[g
	int						m_nOTMax;											//!< e[uő吔
	int						m_nOT[ OBJECT_MAX ];								//!< `e[u

	// IuWFNg
	D3DTEXTURE				m_D3DTex[ TEXTURE_MAX ];							//!< eNX`\
	D3DOBJECT				m_D3DObj[ OBJECT_MAX ];								//!< IuWFNg\

protected:
public:

};

// OO[oϐ---------------------------------------------------------

// O֐vg^Cv錾---------------------------------------------------

}	// namespace	DL

#ifdef __cplusplus
}
#endif

#endif	// __DLGRAPH_INCLUDE__
